pro imageObject::display

tv, *self.data, true=self.true

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject::setSource, source

a = 0
@_krsprivate
;@_krsprotected

self.source = source

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject::setProperty, source=source, name=name, date=date

if n_elements(source) ne 0 then self->setSource, source
if n_elements(name) then self.name = name
if n_elements(date) then self.date = date

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function imageObject::getProperty, data=data, name=name, $
     source=source, date=date

if keyword_set(data) or arg_present(data) then return, *self.data
if keyword_set(name) or arg_present(name) then return, self.name
if keyword_set(source) or arg_present(source) then return, self.source
if keyword_set(date) or arg_present(date) then return, self.date
     
return,-1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject::getProperty, _ref_extra=extra
; really cool way to get variables from the function.  
;This makes the code so much easier to maintain.

for ridx=0,n_elements(extra)-1 do begin
  kw = extra[ridx]
  (scope_varfetch(kw, /ref_extra)) = self->getProperty(_extra=kw)
endfor

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function imageObject::DWFGetProperty,_ref_extra=e 

self->DWFGetProperty,_extra=e 
return,scope_varfetch(e[0],/ref_extra) 

end 

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject::DWFGetProperty,_ref_extra=e 

tags=tag_names(create_struct(name=obj_class(self))) 
for i=0,n_elements(e)-1 do begin 
   wh=where(tags eq e[i],cnt) 
   if cnt eq 0 then continue 
   (scope_varfetch(e[i],/ref_extra))=self.(wh[0]) 
endfor 

return & end 
      
;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject::cleanup

ptr_free, self.data

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function imageObject::init, imageData

self.data = ptr_new(imageData)
;check to see if it true color or not
if size(image,/dimen) eq 3 then self.true = 1 else self.true = 0

return,1 
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro imageObject__define
;since the next line only defines our object the variable it creates is irrelevant since
;we never use it. To signify that it is irrelevant I use the name void. 

void = {imageObject, $
        data : ptr_new(), $
        true : 0L, $
        name : '', $
        source : '', $
        date : 0.0D }

return & end