function thumbnailObject::getStructure

retVal = {thumbnailObject}
struct_assign, self, retval

return, retVal
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro thumbnailObject::display

tv, *self.thumbnail, true=self.true

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function thumbnailObject::getProperty, xsize=xsize, ysize=ysize, _ref_extra=refExtra

if n_elements(refExtra) gt 0 then return, self->imageObject::getProperty( _extra=refExtra)
if keyword_set(xsize) or arg_present(xsize) then return, self.xsize
if keyword_set(ysize) or arg_present(ysize) then return, self.ysize

return, -1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

;pro thumbnailObject::getProperty, _ref_extra=Extra ; xsize=xsize, ysize=ysize,
;
;;if n_elements(refExtra) gt 0 then 
;;self->imageObject::getProperty, _extra=refExtra
;;if arg_present(xsize) then xsize = self.xsize
;;if arg_present(ysize) then ysize = self.ysize
;
;for ridx=0,n_elements(extra)-1 do begin
;  kw = extra[ridx]
;  (scope_varfetch(kw, /ref_extra)) = self->getProperty(_extra=kw)
;endfor
;return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro thumbnailObject::setProperty, xsize=xsize, ysize=ysize, _extra=extra

if n_elements(extra) gt 0 then self->imageObject::setProperty, _extra=extra
if n_elements(xsize) ne 0 then self.xsize = xsize
if n_elements(ysize) ne 0 then self.ysize = ysize

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro thumbnailObject::cleanup

self->imageObject::cleanup

ptr_free, self.thumbnail

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function thumbnailObject::init, imageData, xsize=xsize, ysize=ysize
if not keyword_set(xsize) then xsize=50
if not keyword_set(ysize) then ysize=50
;if the superclass init fails then return a zero
status = self->imageObject::init(imageData)
if status ne 1 then return,0
;the parent object determines the type of image and we have
;access to it here
if self.true eq 0 then begin
  thumbImage = congrid( *self.data, xsize, ysize)
endif else begin
  thumbImage = congrid( *self.data, 3, xsize, ysize)
endelse

self.thumbnail = ptr_new(thumbImage,/no_copy)
self.xsize = xsize
self.ysize = ysize
 
return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro thumbnailObject__define

void = {thumbnailObject, $
        inherits imageObject, $
        thumbnail : ptr_new(), $
        xsize : 0, $
        ysize : 0 }

return & end        